Loading...
Searching...
No Matches
Opm::Brine< Scalar, H2O > Class Template Reference

A class for the brine fluid properties. More...

`#include <Brine.hpp>`

Inheritance diagram for Opm::Brine< Scalar, H2O >:

## Static Public Member Functions

static std::string_view | name ()
| A human readable name for the component.
static bool | gasIsIdeal ()
| Returns true iff the gas phase is assumed to be ideal.
static bool | gasIsCompressible ()
| Returns true iff the gas phase is assumed to be compressible.
static bool | liquidIsCompressible ()
| Returns true iff the liquid phase is assumed to be compressible.
static Scalar | molarMass ()
| The molar mass in of the component.
static Scalar | criticalTemperature ()
| Returns the critical temperature of water.
static Scalar | criticalPressure ()
| Returns the critical pressure of water.
static Scalar | criticalVolume ()
| Returns the critical volume of water.
static Scalar | acentricFactor ()
static Scalar | tripleTemperature ()
| Returns the temperature at water's triple point.
static Scalar | triplePressure ()
| Returns the pressure at water's triple point.
template<class Evaluation>
static Evaluation | vaporPressure (const Evaluation &T)
| The vapor pressure in of pure water at a given temperature.
template<class Evaluation>
static Evaluation | gasEnthalpy (const Evaluation &temperature, const Evaluation &pressure)
| Specific enthalpy of the pure component in gas.
template<class Evaluation>
static Evaluation | liquidEnthalpy (const Evaluation &temperature, const Evaluation &pressure)
| Specific enthalpy of the pure component in liquid.
template<class Evaluation>
static Evaluation | liquidHeatCapacity (const Evaluation &temperature, const Evaluation &pressure)
| Specific isobaric heat capacity of liquid water .
template<class Evaluation>
static Evaluation | gasHeatCapacity (const Evaluation &temperature, const Evaluation &pressure)
| Specific isobaric heat capacity of water steam .
template<class Evaluation>
static Evaluation | gasInternalEnergy (const Evaluation &temperature, const Evaluation &pressure)
| Specific internal energy of steam and water vapor .
template<class Evaluation>
static Evaluation | liquidInternalEnergy (const Evaluation &temperature, const Evaluation &pressure)
| Specific internal energy of liquid water .
template<class Evaluation>
static Evaluation | gasDensity (const Evaluation &temperature, const Evaluation &pressure)
| The density of steam in at a given pressure and temperature.
template<class Evaluation>
static Evaluation | liquidDensity (const Evaluation &temperature, const Evaluation &pressure, bool extrapolate=false)
| The density of the liquid component at a given pressure in and temperature in .
template<class Evaluation>
static Evaluation | liquidDensity (const Evaluation &temperature, const Evaluation &pressure, const Evaluation &rhow)
| The density of the liquid component at a given pressure in and temperature in .
template<class Evaluation>
static Evaluation | gasPressure (const Evaluation &temperature, const Evaluation &density)
| The pressure of steam in at a given density and temperature.
template<class Evaluation>
static Evaluation | liquidPressure (const Evaluation &temperature, const Evaluation &density)
| The pressure of liquid water in at a given density and temperature.
template<class Evaluation>
static Evaluation | gasViscosity (const Evaluation &temperature, const Evaluation &pressure)
| The dynamic viscosity of steam.
template<class Evaluation>
static Evaluation | liquidViscosity (const Evaluation &temperature, const Evaluation &)
| The dynamic viscosity of pure water.
Static Public Member Functions inherited from Opm::Component< Scalar, Brine< Scalar, H2O > >
static void | init (Scalar, Scalar, unsigned, Scalar, Scalar, unsigned)
| A default routine for initialization, not needed for components and must not be called.
static bool | gasIsCompressible ()
| Returns true iff the gas phase is assumed to be compressible.
static bool | gasIsIdeal ()
| Returns true iff the gas phase is assumed to be ideal.
static bool | liquidIsCompressible ()
| Returns true iff the liquid phase is assumed to be compressible.
static std::string_view | name ()
| A human readable name for the component.
static Scalar | molarMass ()
| The molar mass in of the component.
static Scalar | criticalTemperature ()
| Returns the critical temperature in of the component.
static Scalar | criticalPressure ()
| Returns the critical pressure in of the component.
static Scalar | acentricFactor ()
| Returns the acentric factor of the component.
static Scalar | criticalVolume ()
| Returns the critical volume in of the component.
static Scalar | tripleTemperature ()
| Returns the temperature in at the component's triple point.
static Scalar | triplePressure ()
| Returns the pressure in at the component's triple point.
static Evaluation | vaporPressure (const Evaluation &)
| The vapor pressure in of the component at a given temperature in .
static Evaluation | gasDensity (const Evaluation &, const Evaluation &)
| The density in of the component at a given pressure in and temperature in .
static Evaluation | liquidDensity (const Evaluation &, const Evaluation &)
| The density of the liquid component at a given pressure in and temperature in .
static Evaluation | gasEnthalpy (const Evaluation &, const Evaluation &)
| Specific enthalpy of the pure component in gas.
static Evaluation | liquidEnthalpy (const Evaluation &, const Evaluation &)
| Specific enthalpy of the pure component in liquid.
static Evaluation | gasInternalEnergy (const Evaluation &, const Evaluation &)
| Specific internal energy of the pure component in gas.
static Evaluation | liquidInternalEnergy (const Evaluation &, const Evaluation &)
| Specific internal energy of pure the pure component in liquid.
static Evaluation | gasViscosity (const Evaluation &, const Evaluation &)
| The dynamic viscosity of the pure component at a given pressure in and temperature in .
static Evaluation | liquidViscosity (const Evaluation &, const Evaluation &)
| The dynamic liquid viscosity of the pure component.
static Evaluation | gasThermalConductivity (const Evaluation &, const Evaluation &)
| Thermal conductivity of the component [W/(m^2 K/m)] as a gas.
static Evaluation | liquidThermalConductivity (const Evaluation &, const Evaluation &)
| Thermal conductivity of the component [W/(m^2 K/m)] as a liquid.
static Evaluation | gasHeatCapacity (const Evaluation &, const Evaluation &)
| Specific isobaric heat capacity of the component [J/kg] as a gas.
static Evaluation | liquidHeatCapacity (const Evaluation &, const Evaluation &)
| Specific isobaric heat capacity of the component [J/kg] as a liquid.

## Static Public Attributes

static Scalar | salinity
| The mass fraction of salt assumed to be in the brine.
Static Public Attributes inherited from Opm::Component< Scalar, Brine< Scalar, H2O > >
static constexpr bool | isTabulated

## Additional Inherited Members

Public Types inherited from Opm::Component< Scalar, Brine< Scalar, H2O > >
typedef Scalar | Scalar

## Detailed Description

template<class Scalar, class H2O>
class Opm::Brine< Scalar, H2O >

A class for the brine fluid properties.

Template Parameters

  Scalar | The type used for scalar values
  H2O | Static polymorphism: the Brine class can access all properties of the H2O class

## Member Function Documentation

## acentricFactor()

template<class Scalar, class H2O>

Scalar Opm::Brine< Scalar, H2O >::acentricFactor | ( |  | ) |

inline static

## criticalPressure()

template<class Scalar, class H2O>

Scalar Opm::Brine< Scalar, H2O >::criticalPressure | ( |  | ) |

inline static

Returns the critical pressure of water.

## criticalTemperature()

template<class Scalar, class H2O>

Scalar Opm::Brine< Scalar, H2O >::criticalTemperature | ( |  | ) |

inline static

Returns the critical temperature of water.

## criticalVolume()

template<class Scalar, class H2O>

Scalar Opm::Brine< Scalar, H2O >::criticalVolume | ( |  | ) |

inline static

Returns the critical volume of water.

## gasDensity()

template<class Scalar, class H2O>
template<class Evaluation>

Evaluation Opm::Brine< Scalar, H2O >::gasDensity | ( | const Evaluation & | temperature,
|  | const Evaluation & | pressure )

inline static

The density of steam in at a given pressure and temperature.

See:

IAPWS: "Revised Release on the IAPWS Industrial Formulation 1997 for the Thermodynamic Properties of Water and Steam", http://www.iapws.org/relguide/IF97-Rev.pdf

Parameters

  temperature | Absolute temperature of the fluid in
  pressure | Phase pressure in

## gasEnthalpy()

template<class Scalar, class H2O>
template<class Evaluation>

Evaluation Opm::Brine< Scalar, H2O >::gasEnthalpy | ( | const Evaluation & | temperature,
|  | const Evaluation & | pressure )

inline static

Specific enthalpy of the pure component in gas.

Parameters

  temperature | temperature of component in
  pressure | pressure of component in

## gasHeatCapacity()

template<class Scalar, class H2O>
template<class Evaluation>

Evaluation Opm::Brine< Scalar, H2O >::gasHeatCapacity | ( | const Evaluation & | temperature,
|  | const Evaluation & | pressure )

inline static

Specific isobaric heat capacity of water steam .

See:

IAPWS: "Revised Release on the IAPWS Industrial Formulation 1997 for the Thermodynamic Properties of Water and Steam", http://www.iapws.org/relguide/IF97-Rev.pdf

Parameters

  temperature | Absolute temperature of the fluid in
  pressure | Phase pressure in

## gasInternalEnergy()

template<class Scalar, class H2O>
template<class Evaluation>

Evaluation Opm::Brine< Scalar, H2O >::gasInternalEnergy | ( | const Evaluation & | temperature,
|  | const Evaluation & | pressure )

inline static

Specific internal energy of steam and water vapor .

See:

IAPWS: "Revised Release on the IAPWS Industrial Formulation 1997 for the Thermodynamic Properties of Water and Steam", http://www.iapws.org/relguide/IF97-Rev.pdf

Parameters

  temperature | Absolute temperature of the fluid in
  pressure | Phase pressure in

## gasIsCompressible()

template<class Scalar, class H2O>

bool Opm::Brine< Scalar, H2O >::gasIsCompressible | ( |  | ) |

inline static

Returns true iff the gas phase is assumed to be compressible.

## gasIsIdeal()

template<class Scalar, class H2O>

bool Opm::Brine< Scalar, H2O >::gasIsIdeal | ( |  | ) |

inline static

Returns true iff the gas phase is assumed to be ideal.

## gasPressure()

template<class Scalar, class H2O>
template<class Evaluation>

Evaluation Opm::Brine< Scalar, H2O >::gasPressure | ( | const Evaluation & | temperature,
|  | const Evaluation & | density )

inline static

The pressure of steam in at a given density and temperature.

See:

IAPWS: "Revised Release on the IAPWS Industrial Formulation 1997 for the Thermodynamic Properties of Water and Steam", http://www.iapws.org/relguide/IF97-Rev.pdf

Parameters

  temperature | Absolute temperature of the fluid in
  density | Density in

## gasViscosity()

template<class Scalar, class H2O>
template<class Evaluation>

Evaluation Opm::Brine< Scalar, H2O >::gasViscosity | ( | const Evaluation & | temperature,
|  | const Evaluation & | pressure )

inline static

The dynamic viscosity of steam.

This method is only valid if pressure is below or at the vapor pressure of water.

See:

IAPWS: "Release on the IAPWS Formulation 2008 for the Viscosity of Ordinary Water Substance", http://www.iapws.org/relguide/visc.pdf

Parameters

  temperature | Absolute temperature of the fluid in
  pressure | Phase pressure in

## liquidDensity() [1/2]

template<class Scalar, class H2O>
template<class Evaluation>

Evaluation Opm::Brine< Scalar, H2O >::liquidDensity | ( | const Evaluation & | temperature,
|  | const Evaluation & | pressure,
|  | bool | extrapolate = false )

inline static

The density of the liquid component at a given pressure in and temperature in .

Parameters

  temperature | temperature of component in
  pressure | pressure of component in
  extrapolate | True to use extrapolation

Equations given in:

- Batzle & Wang (1992)
- cited by: Adams & Bachu in Geofluids (2002) 2, 257-271

## liquidDensity() [2/2]

template<class Scalar, class H2O>
template<class Evaluation>

Evaluation Opm::Brine< Scalar, H2O >::liquidDensity | ( | const Evaluation & | temperature,
|  | const Evaluation & | pressure,
|  | const Evaluation & | rhow )

inline static

The density of the liquid component at a given pressure in and temperature in .

Parameters

  temperature | temperature of component in
  pressure | pressure of component in
  rhow | Density of liquid

Equations given in:

- Batzle & Wang (1992)
- cited by: Adams & Bachu in Geofluids (2002) 2, 257-271

## liquidEnthalpy()

template<class Scalar, class H2O>
template<class Evaluation>

Evaluation Opm::Brine< Scalar, H2O >::liquidEnthalpy | ( | const Evaluation & | temperature,
|  | const Evaluation & | pressure )

inline static

Specific enthalpy of the pure component in liquid.

Parameters

  temperature | temperature of component in
  pressure | pressure of component in

Equations given in:

- Palliser & McKibbin 1997
- Michaelides 1981
- Daubert & Danner 1989

## liquidHeatCapacity()

template<class Scalar, class H2O>
template<class Evaluation>

Evaluation Opm::Brine< Scalar, H2O >::liquidHeatCapacity | ( | const Evaluation & | temperature,
|  | const Evaluation & | pressure )

inline static

Specific isobaric heat capacity of liquid water .

See:

IAPWS: "Revised Release on the IAPWS Industrial Formulation 1997 for the Thermodynamic Properties of Water and Steam", http://www.iapws.org/relguide/IF97-Rev.pdf

Parameters

  temperature | Absolute temperature of the fluid in
  pressure | Phase pressure in

## liquidInternalEnergy()

template<class Scalar, class H2O>
template<class Evaluation>

Evaluation Opm::Brine< Scalar, H2O >::liquidInternalEnergy | ( | const Evaluation & | temperature,
|  | const Evaluation & | pressure )

inline static

Specific internal energy of liquid water .

See:

IAPWS: "Revised Release on the IAPWS Industrial Formulation 1997 for the Thermodynamic Properties of Water and Steam", http://www.iapws.org/relguide/IF97-Rev.pdf

Parameters

  temperature | Absolute temperature of the fluid in
  pressure | Phase pressure in

## liquidIsCompressible()

template<class Scalar, class H2O>

bool Opm::Brine< Scalar, H2O >::liquidIsCompressible | ( |  | ) |

inline static

Returns true iff the liquid phase is assumed to be compressible.

## liquidPressure()

template<class Scalar, class H2O>
template<class Evaluation>

Evaluation Opm::Brine< Scalar, H2O >::liquidPressure | ( | const Evaluation & | temperature,
|  | const Evaluation & | density )

inline static

The pressure of liquid water in at a given density and temperature.

See:

IAPWS: "Revised Release on the IAPWS Industrial Formulation 1997 for the Thermodynamic Properties of Water and Steam", http://www.iapws.org/relguide/IF97-Rev.pdf

Parameters

  temperature | Absolute temperature of the fluid in
  density | Density of the fluid in

## liquidViscosity()

template<class Scalar, class H2O>
template<class Evaluation>

Evaluation Opm::Brine< Scalar, H2O >::liquidViscosity | ( | const Evaluation & | temperature,
|  | const Evaluation & | )

inline static

The dynamic viscosity of pure water.

See:

IAPWS: "Release on the IAPWS Formulation 2008 for the Viscosity of Ordinary Water Substance", http://www.iapws.org/relguide/visc.pdf

Parameters

  temperature | Absolute temperature of the fluid in
  pressure | Phase pressure in
  extrapolate | True to use extrapolation

Equation given in:

- Batzle & Wang (1992)
- cited by: Bachu & Adams (2002) "Equations of State for basin geofluids"

## molarMass()

template<class Scalar, class H2O>

Scalar Opm::Brine< Scalar, H2O >::molarMass | ( |  | ) |

inline static

The molar mass in of the component.

This assumes that the salt is pure NaCl.

## name()

template<class Scalar, class H2O>

std::string_view Opm::Brine< Scalar, H2O >::name | ( |  | ) |

inline static

A human readable name for the component.

## triplePressure()

template<class Scalar, class H2O>

Scalar Opm::Brine< Scalar, H2O >::triplePressure | ( |  | ) |

inline static

Returns the pressure at water's triple point.

## tripleTemperature()

template<class Scalar, class H2O>

Scalar Opm::Brine< Scalar, H2O >::tripleTemperature | ( |  | ) |

inline static

Returns the temperature at water's triple point.

## vaporPressure()

template<class Scalar, class H2O>
template<class Evaluation>

Evaluation Opm::Brine< Scalar, H2O >::vaporPressure | ( | const Evaluation & | T | ) |

inline static

The vapor pressure in of pure water at a given temperature.

See:

IAPWS: "Revised Release on the IAPWS Industrial Formulation 1997 for the Thermodynamic Properties of Water and Steam", http://www.iapws.org/relguide/IF97-Rev.pdf

Parameters

  T | Absolute temperature of the system in

The documentation for this class was generated from the following file:

- opm/material/components/Brine.hpp